3 # Desc: Records gps data until midnight
4 # Author: Steven Baltakatei Sandoval; License: GPLv3+
5 # Usage: bkgpslog --output [output dir]
7 #==BEGIN Define script parameters==
8 PATH
="/opt/bktei:$PATH" # Add default baltakatei script install directory to PATH (necessary for other bk scripts)
9 SCRIPT_HOSTNAME
=$
(hostname
) # Save hostname of system running this script.
10 SCRIPT_VERSION
="bkgpslog 0.0.1" # Define version of script.
11 SCRIPT_TIME_SHORT
="$(date +%Y%m%dT%H%M%S%z)" # Save current date & time in ISO-8601 format.
12 SCRIPT_DATE_SHORT
="$(date +%Y%m%d)" # Save current date in ISO-8601 format.
14 declare -Ag appRollCall
# Associative array for storing app status
15 declare -Ag fileRollCall
# Associative array for storing file status
16 declare -Ag dirRollCall
# Associative array for storing dir status
18 #===BEGIN Declare local script functions===
20 # Desc: If arg is a command, save result in assoc array 'appRollCall'
21 # Usage: checkapp arg1 arg2 arg3 ...
22 # Input: global assoc. array 'appRollCall'
23 # Output: adds/updates key(value) to global assoc array 'appRollCall'
25 #echo "DEBUG:$(date +%S.%N)..Starting checkapp function."
26 #echo "DEBUG:args: $@"
27 #echo "DEBUG:returnState:$returnState"
31 #echo "DEBUG:processing arg:$arg"
32 if command -v "$arg" 1>/dev
/null
2>&1; then # Check if arg is a valid command
33 appRollCall
[$arg]="true";
34 #echo "DEBUG:appRollCall[$arg]:"${appRollCall[$arg]}
35 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
37 appRollCall
[$arg]="false"; returnState
="false";
41 #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
42 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
44 #===Determine function return code===
45 if [ "$returnState" = "true" ]; then
46 #echo "DEBUG:checkapp returns true for $arg";
49 #echo "DEBUG:checkapp returns false for $arg";
52 } # Check that app exists
54 # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
55 # Usage: checkfile arg1 arg2 arg3 ...
56 # Input: global assoc. array 'fileRollCall'
57 # Output: adds/updates key(value) to global assoc array 'fileRollCall';
58 # Output: returns 0 if app found, 1 otherwise
63 #echo "DEBUG:processing arg:$arg"
64 if [ -f "$arg" ]; then
65 fileRollCall
["$arg"]="true";
66 #echo "DEBUG:fileRollCall[\"$arg\"]:"${fileRollCall["$arg"]}
67 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
69 fileRollCall
["$arg"]="false"; returnState
="false";
73 #for key in "${!fileRollCall[@]}"; do echo "DEBUG:fileRollCall key [$key] is:${fileRollCall[$key]}"; done
74 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
76 #===Determine function return code===
77 if [ "$returnState" = "true" ]; then
78 #echo "DEBUG:checkapp returns true for $arg";
81 #echo "DEBUG:checkapp returns false for $arg";
84 } # Check that file exists
86 # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
87 # Usage: checkdir arg1 arg2 arg3 ...
88 # Input: global assoc. array 'dirRollCall'
89 # Output: adds/updates key(value) to global assoc array 'dirRollCall';
90 # Output: returns 0 if app found, 1 otherwise
95 #echo "DEBUG:processing arg:$arg"
96 if [ -d "$arg" ]; then
97 dirRollCall
["$arg"]="true";
98 #echo "DEBUG:dirRollCall[\"$arg\"]:"${dirRollCall["$arg"]}
99 if ! [ "$returnState" = "false" ]; then returnState
="true"; fi
101 dirRollCall
["$arg"]="false"; returnState
="false";
105 #for key in "${!dirRollCall[@]}"; do echo "DEBUG:dirRollCall key [$key] is:${dirRollCall[$key]}"; done
106 #echo "DEBUG:evaluating returnstate. returnState:"$returnState
108 #===Determine function return code===
109 if [ "$returnState" = "true" ]; then
110 #echo "DEBUG:checkapp returns true for $arg";
113 #echo "DEBUG:checkapp returns false for $arg";
116 } # Check that dir exists
118 # Yell, Die, Try Three-Fingered Claw technique
119 # Ref/Attrib: https://stackoverflow.com/a/25515370
120 yell
() { echo "$0: $*" >&2; }
121 die
() { yell
"$*"; exit 111; }
122 try
() { "$@" || die
"cannot $*"; }
125 echo "$@" 1>&2; # Define stderr echo function.
126 } # Define stderr message function.
129 echoerr
" bkgpslog.sh [ options ]"
132 echoerr
" -h, --help"
133 echoerr
" Display help information."
136 echoerr
" Display script version."
138 echoerr
" -v, --verbose"
139 echoerr
" Display debugging info."
141 echoerr
" -o, --output [ directory ]"
142 echoerr
" Specify output directory to save logs."
143 } # Display information on how to use this script.
145 echoerr
"$SCRIPT_VERSION"
146 } # Display script version.
148 # Usage: vbm "DEBUG:verbose message here"
149 # Description: Prints verbose message ("vbm") to stderr if OPTION_VERBOSE is set to "true".
151 # - OPTION_VERBOSE variable set by processArguments function. (ex: "true", "false")
152 # - "$@" positional arguments fed to this function.
154 # Script function dependencies: echoerr
155 # External function dependencies: echo
156 # Last modified: 2020-04-11T23:57Z
157 # Last modified by: Steven Baltakatei Sandoval
161 if [ "$OPTION_VERBOSE" = "true" ]; then
162 FUNCTION_TIME
=$
(date --iso-8601=ns
); # Save current time in nano seconds.
163 echoerr
"[$FUNCTION_TIME] ""$*"; # Display argument text.
167 return 0; # Function finished.
168 } # Verbose message display function.
170 while [ ! $# -eq 0 ]; do # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
171 echoerr
"DEBUG:Starting processArguments while loop."
172 echoerr
"DEBUG:Provided arguments are:""$*"
174 --h |
--help) showUsage
; exit 1;; # Display usage.
175 --version) showVersion
; exit 1;; # Show version
176 --v |
--verbose) OPTION_VERBOSE
="true"; vbm
"DEBUG:Verbose mode enabled.";; # Enable verbose mode.
177 --o |
--output) if [ -d "$2" ]; then DIROUT
="$2"; fi ;; # Define output directory.
178 *) echoerr
"ERROR: Unrecognized argument."; exit 1;; # Handle unrecognized options.
182 } # Argument Processing
184 # Desc: Report seconds until midnight
185 # Output: stdout: integer seconds until midnight
186 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
187 # Usage: timeUntilMidnight
188 # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi
190 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
191 TIME_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
192 DATE_CURRENT
="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
193 DATE_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day.
194 DATE_TOMORROW
="$(date -d "$TIME_CURRENT next day
" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
195 TIME_NEXT_MIDNIGHT
="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second).
196 SECONDS_UNTIL_NEXT_MIDNIGHT
="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
197 if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then
199 elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then
200 returnState
="WARNING_ZERO";
201 yell
"WARNING:Reported time until midnight exactly zero.";
202 elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then
203 returnState
="WARNING_NEGATIVE";
204 yell
"WARNING:Reported time until midnight is negative.";
207 try
echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report
209 #===Determine function return code===
210 if [[ "$returnState" = "true" ]]; then
212 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
214 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
217 } # Report seconds until next midnight
219 # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
220 # Usage: dateTimeShort
221 # Output: stdout: timestamp (ISO-8601, no separators)
222 TIME_CURRENT
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
223 TIME_CURRENT_SHORT
="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
224 echo "$TIME_CURRENT_SHORT";
225 } # Get date&time without separators
227 processArguments
"$@" # Process arguments.
228 if checkapp gpspipe
&& checkdir
"$DIROUT"; then
229 # Determine output file paths
230 FILEOUT_NMEA
="$(dateTimeShort)"..
"$SCRIPT_HOSTNAME"_location.nmea
;
234 # Determine script lifespan (note: exit if <= 0 since 'timeout' runs forever if provided "0s".
235 #if ! scriptTTL="$(timeUntilMidnight)"; then yell "ERROR: timeUntilMidnight exit code $?"; exit 1; fi
236 scriptTTL
="60"; #DEBUG DEBUG DEBUG DEBUG
238 # Determine buffer lifespan
241 # Record gps data until life ends
242 declare debugCounter
; debugCounter
="0"
243 while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
245 timeout
"$bufferTTL""s" gpspipe
-r 1>> "$DIROUT"/"$FILEOUT_NMEA""$debugCounter"
246 echo "do stuff" 1>&2;
250 #===END Declare local script functions===
251 #==END Define script parameters==
254 #==BEGIN Perform work and exit==
255 main
"$@" # Run main function.
257 #==END Perform work and exit==
261 #gpspipe -r -d -l -o "$DIROUT1"/"$FILEOUT1" ;